from ..utility.format import Format
from ..utility.trainingObservables import Observable, TrainingObservables


class NetworkObservables(TrainingObservables):
    """
    Stores all the observables of the training process.
    It tracks the training and validation loss during training and writes out the learning rate.
    Additionally, it prints/writes the losses to CLI/a log file and plots the losses after training.
    """
    __slots__ = ['losses', 'validation', 'accuracy', 'learningRate']

    def __init__(self, epochs: int) -> None:
        super().__init__(epochs)
        self.losses = Observable(epochs, colors='descending')
        self.validation = Observable(epochs, colors='descending')
        self.accuracy = Observable(epochs, colors='ascending')
        self.learningRate = Observable(epochs)
